//modified:2001.05.22@13:00 by Alex

//last changes:
// enabled and updated properties like enabled and periodic
// solved problems with FID

/////////////////////////////////////////////////////////////////////
//   durch die Verwaltung der FIDs kam es zu folgenden Fehlern:    //
/////////////////////////////////////////////////////////////////////

{ Fehler 1:
 Wenn es zwei MM_Timer gibt (beide periodisch), geht folgendes nicht: (siehe procedure TMMTimer.UpdateTimer)
 (on:=enabled=true;off:=enabled=false)

1 On
2 On
2 Off
1 Off
2 On
1 On
Resultat: nur noch 1 luft}

{ Fehler 2:
 Wenn es zwei MM_Timer gibt (1 periodisch, 2 nicht), geht folgendes nicht:
 (on:=enabled=true;off:=enabled=false)
2 On
1 On (NACHDEM 2 ausgelst wurde)
2 Off
Resultat: kein Timer luft}

unit MM_Timer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MMSystem;

const
	WM_MMTimer = WM_USER + $1000;

type
  TFNTimeCallBack = procedure(uTimerID, uMessage: UINT; dwUser, dw1, dw2: DWORD);
    pascal;  //Pascal notwendig!!! (Falsch dekl. in MMSystem);
type
  TMMTimerEvent = procedure(Sender: TObject; Time: Cardinal)of object;
  TMMTimer = class(TComponent)
  private
    { Private-Deklarationen }
    FWnd: hWnd;                      //FensterHandle
    FTimeCaps: TTimeCaps;            //Dev-Caps MMTimer
    FEnabled: Boolean;
    FInterval: Cardinal;
    FResolution: Cardinal;
    FPeriodic: Boolean;
    FID: Integer;                    // ID des MMTimers
    FOnTimer: TMMTimerEvent;
    FResult: Integer;
  protected
    { Protected-Deklarationen }
    procedure UpdateTimer;
    procedure SetEnabled(Value: Boolean);
    procedure SetInterval(Value: Cardinal);
    procedure SetResolution(Value: Cardinal);
    procedure SetPeriodic(Value: Boolean);
    procedure WndProc(var Msg: TMessage);
    procedure DoOnTimer(Time: Cardinal); dynamic;
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Result: Integer read FResult;
//    procedure SetCallback(Value: TFNTimeCallback);
  published
    { Published-Deklarationen }
    property Interval: Cardinal read FInterval write SetInterval;        //Interval / Start
    property Resolution: Cardinal read FResolution write SetResolution;  //Genauigkeit
    property Periodic: Boolean read FPeriodic write SetPeriodic;         // OnShot oder Periodisch
    property Enabled: Boolean read FEnabled write SetEnabled;
    property OnTimer: TMMTimerEvent read FOnTimer write FOnTimer;        // Ereignis
  end;

procedure Register;

implementation

procedure TimeCallback(TimerID,         //ID von timeSetEvent
                       Msg: UINT;       //reserviert
                       dwUser,          //UserDaten aus timeSetEvent
                       dw1,             //reserviert
                       dw2: DWord);     //reserviert
                       pascal;
begin
  PostMessage(dwUser, WM_MMTimer, TimeGetTime, 0);
end;

constructor TMMTimer.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FWnd:= AllocateHWnd(WndProc);
  FResult:= timeGetDevCaps(@FTimeCaps, SizeOf(FTimeCaps));
  FResolution:= FTimeCaps.wPeriodMin;
  FInterval:= FTimeCaps.wPeriodMax;
  FResult:= timeBeginPeriod(FResolution);
  FPeriodic:= Periodic;
  FEnabled:= Enabled;
  FID:= 0;
  UpdateTimer;
end;

destructor TMMTimer.Destroy;
begin
  if FID <> 0 then FResult:= timeKillEvent(FID);
  FResult:= timeEndPeriod(FResolution);
  DeallocateHWnd(FWnd);
  inherited Destroy;
end;

procedure TMMTimer.WndProc(var Msg: TMessage);
begin
  with Msg do begin
  if Msg = WM_MMTimer then
    DoOnTimer(wParam)
  else
    DefWindowProc(FWnd, Msg, wParam, lParam);
  end;
end;

procedure TMMTimer.DoOnTimer(Time: Cardinal);
begin
  if Assigned(FOnTimer) then
    FOnTimer(Self, Time);
  if FPeriodic=false then FID:=0;// !!! sonst kommt es zu oben beschriebenem Fehler 2
end;

procedure TMMTimer.UpdateTimer;
var
  Mode: UINT;
begin
  if not (csDesigning in ComponentState) then begin
    if FID <> 0 then begin
      timeKillEvent(FID);
      FID:=0;            // !!! sonst kommt es zu oben beschriebenem Fehler 1
    end;
    if FPeriodic then
      Mode:= TIME_PERIODIC
    else
      Mode:= TIME_ONESHOT;
    if FEnabled then FID:= timeSetEvent(FInterval,
                       FResolution,
                       @TimeCallback,    //Proc-Adr.
                       FWnd,             //User-Daten
                       Mode);
  end;
end;

procedure TMMTimer.SetEnabled(Value: Boolean);
begin
  if Value <> FEnabled then begin
    FEnabled:= Value;
    UpdateTimer;
  end;
end;

procedure TMMTimer.SetInterval(Value: Cardinal);
begin
  if (Value <> FInterval) and (Value >= FTimeCaps.wPeriodMin)
    and (Value <= FTimeCaps.wPeriodMax)then begin
    FInterval:= Value;
    UpdateTimer;
  end;
end;

procedure TMMTimer.SetResolution(Value: Cardinal);
begin
  if (Value <> FResolution) and (Value <= FInterval) then begin
    FResolution:= Value;
    UpdateTimer;
  end;
end;

procedure TMMTimer.SetPeriodic(Value: Boolean);
begin
  if Value <> FPeriodic then begin
    FPeriodic:= Value;
    UpdateTimer;
  end;
end;

procedure Register;
begin
  RegisterComponents('Custom', [TMMTimer]);
end;

end.
